'use strict';

var _camelCase2 = require('lodash/camelCase');

var _camelCase3 = _interopRequireDefault(_camelCase2);

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (_ref) {
    var t = _ref.types;

    return {
        visitor: {
            ExportDefaultDeclaration: function ExportDefaultDeclaration(nodePath, pluginPass) {
                var declaration = undefined,
                    fileName = undefined,
                    id = undefined;

                fileName = pluginPass && pluginPass.file && pluginPass.file.opts && pluginPass.file.opts.filename;
                fileName = fileName && _path2.default.basename(fileName, '.js');
                fileName = (0, _camelCase3.default)(fileName);
                id = t.identifier(fileName);
                declaration = nodePath.node.declaration;

                if (!fileName || !declaration || declaration.type === 'Identifier') {
                    return;
                }
                if (!t.isValidIdentifier(fileName)) {
                    throw Error('Invalid identifier "' + fileName + '".');
                }
                nodePath.replaceWithMultiple([t.variableDeclaration('let', [t.variableDeclarator(id, declaration)]), t.exportDefaultDeclaration(id)]);
            }
        }
    };
};

module.exports = exports['default'];
//# sourceMappingURL=index.js.map
